#include "clock.h"
#include "ui.h"
#include "music.h"
#include "arkos2/setInterruptHandler.h"

u8 timerRuning;
u16 gTickCount, gGameTimer;

void interruptTick (); // Forward

void initTimer ()
{
    resetGameTimer();
    asm_setInterruptHandler ( &interruptTick);
}

u16 getGameClock () {  return gGameTimer; }

void unpauseGameTimer () { timerRuning = 1; }

void pauseGameTimer () { timerRuning = 0; }

void resetGameTimer ()
{
    timerRuning = 0; // u8
    gTickCount =  gGameTimer = 0; // u16
}

void interruptTick ()
{
    static u8 FiftyHz = 0;
    FiftyHz++;
    if (FiftyHz == 6)
    {
        FiftyHz = 0;
        playMusic(); // If a 50 Hz music is running, plays it
    }

    if ( !timerRuning ) return; // If timer is running, then we are inside a game

    gTickCount ++;
    if ( gTickCount == 300 ) // CPC Interrupt is 300 Hz, so it's every second
    {
        gTickCount = 0;
        if (gGameTimer < 999 )  /// No clock above 999 (only 3 characters allowed)...
        {
            gGameTimer ++;
            displayClock(gGameTimer);
        }
    }
}
