#include "music.h"

#include "arkos2/ArkosPlayer2.h"

// Globals exported

// Locals
typedef struct s_sfx t_sfx;
struct s_sfx
{
    u8 num; u8 vol; u8 channel;
} ;

// Does a music needs to update ?
u8 musicOption, musicChanged, sfxChanged;

// Music list / SFX list (see define in music.h) 
void * music_ptr [MAX_MUS] ;
t_sfx sfx[MAX_SFX];

enum
{
    CHANNEL_A,
    CHANNEL_B,
    CHANNEL_C
};
#define MAX_VOL	0

void setsfx (t_sfx *sfx, u8 instr, u8 vol, u8 channel)
{
    sfx->num = instr; sfx->vol = vol; sfx->channel = channel;
}

void initMusic ()
{
    musicOption = 0;
    musicChanged = MAX_MUS;

    music_ptr [MUS_MENU]   = &RGDMENU_START;
    music_ptr [MUS_THEM1]  = &DIFFERENTIALINDUCTOR_START;
    music_ptr [MUS_HSCORE] = &RECORDBREAKERHIGHSCORETHEME_START;
    music_ptr [MUS_WIN]    = &DIFFUSERVICTORYTHEME_START;
    music_ptr [MUS_EMPTY]  = &EMPTYSONG_START;

    sfxChanged = MAX_SFX;
    PLAYER_ARKOS_INITSOUNDEFFECTS (&RGDSFX_SOUNDEFFECTS);

    setsfx (&sfx[SFX_BOOM],1,MAX_VOL,CHANNEL_C);
    setsfx (&sfx[SFX_DIG] ,2,MAX_VOL,CHANNEL_C);
    setsfx (&sfx[SFX_DENY],3,MAX_VOL,CHANNEL_C);
    setsfx (&sfx[SFX_FLAG],4,MAX_VOL,CHANNEL_C);
    setsfx (&sfx[SFX_DFLG],5,MAX_VOL,CHANNEL_C);
}

void startMusic (u8 songNumber)
{
    stopMusic();

    if (musicOption == 2 || (musicOption == 1 && songNumber == MUS_THEM1) )
        songNumber = MUS_EMPTY; // Empty song to allow SFX

    musicChanged = songNumber;
}

void playMusic ()
{
    if (musicChanged < MAX_MUS)
    {
        PLAYER_ARKOS_INIT (music_ptr[musicChanged],0);
        musicChanged = MAX_MUS;
    }

    if (sfxChanged < MAX_SFX)
    {
        PLAYER_ARKOS_PLAYSOUNDEFFECT (sfx[sfxChanged].num, sfx[sfxChanged].vol,sfx[sfxChanged].channel);
        sfxChanged = MAX_SFX;
    }

    PLAYER_ARKOS_PLAY ();
}

void stopMusic ()
{
    PLAYER_ARKOS_STOP();
}

void playSFX (u8 sfxNumber)
{
    sfxChanged = sfxNumber;
}

void stopSFX ()
{
    PLAYER_ARKOS_STOPSOUNDEFFECTFROMCHANNEL (7);
}

u8 getMusicOption ()
{
    return musicOption;
}

// 0 : Full music, 1 : only menu, 2 : No music
void changeMusicOption()
{
    musicOption++;
    if (musicOption == 3)
        musicOption = 0;

    startMusic(MUS_MENU);
}
